﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Workflow;
using Microsoft.SharePoint.WorkflowActions;

namespace WorkflowProjectWithTask.Workflow1
{
    public sealed partial class Workflow1 : SequentialWorkflowActivity
    {
        public Workflow1()
        {
            InitializeComponent();
        }

        public Guid workflowId = default(System.Guid);
        public SPWorkflowActivationProperties workflowProperties = new SPWorkflowActivationProperties();
        public Guid taskId = default(System.Guid);
        public SPWorkflowTaskProperties taskProperties = new Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties();
        public SPWorkflowTaskProperties taskAfterProperties = new Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties();
        public SPWorkflowTaskProperties taskBeforeProperties = new Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties();

        private bool isTaskCompleted = false;

        private void createTask1_MethodInvoking(object sender, EventArgs e)
        {
            // Creating a new Task, assigned to the Person indicated in the field Manager existing in the List 
            // The field Manager must be configured with Show field option as Account.
            taskId = Guid.NewGuid();
            string sManager = workflowProperties.Item["Manager"].ToString();
            SPFieldLookupValue fld = new SPFieldLookupValue(sManager);
            taskProperties.AssignedTo = fld.LookupValue;
            taskProperties.Title = "Review Item, please.";
            taskProperties.DueDate = DateTime.Today.AddDays(7);
            taskProperties.SendEmailNotification = false;
        }

        private void onTaskChanged1_Invoked(object sender, ExternalDataEventArgs e)
        {
            // Check if the Task is already completed. If so, let the While Activity know that we have finished !
            Guid statusFieldID = workflowProperties.TaskList.Fields["Status"].Id;
            string taskStatus = taskAfterProperties.ExtendedProperties[statusFieldID].ToString();
            if (!string.IsNullOrEmpty(taskStatus) && taskStatus == "Completed")
            {
                this.isTaskCompleted = true;
            }
        }
    }
}
